# coding=iso-8859-15

"""
Newsflash IMDb extension script.

This extension will request for a Movie Title
and will then try to retrieve some basic information
about the movie from the IMDb Internet Movie Database
and show it to the user.

Please modify this script to suit your needs.

Copyright (c) Sami Visnen 2008
"""

import flash.widget
import flash.host
import imdb
import re

flash.host.add_log('$Id: extension_imdb.py,v 1.6 2008/05/21 23:28:29 enska Exp $')

ExtWnd=None
Titles=None

def start_search(movie):
    global Titles
    if len(movie) == 0:
        ExtWnd[4].items=None
        ExtWnd[5].data=None
        Titles=None
        return
    
    flash.host.show_msg("Querying IMDd database (http://akas.imdb.com)...")
    db  = imdb.IMDb()
    Titles = db.search_movie(movie)
    flash.host.show_msg("Query done found " + str(len(Titles)) + ' titles');
    names = []
    for title in Titles:
        names.append(title['long imdb canonical title'])

    # show the new list
    ExtWnd[4].items = names
    # enable scrolling
    ExtWnd[4].scroll = 1

def movie_title_click(start, end):
    if Titles==None:
        return
    
    movie = Titles[start]
    title = movie['long imdb canonical title']
    flash.host.show_msg('Querying details for "' + title + '"')

    db = imdb.IMDb()
    db.update(movie)
    # Sometimes this blows up with the dreaded UnicodeDecodeError.
    # I guess the problem is in IMDbPy. But maybe there could be a workaround?
    summary = movie.summary()

    # for some reason sometimes in the Country list you get something like
    # "Country: UK | USA", where there also are new lines around the pipe.
    # get rid of the silly newlines
    hack = re.compile('(\r|\n| )*\|(\r|\n| )*')
    summary = hack.sub(' | ', summary)

    ExtWnd[5].data = summary

    flash.host.show_msg("")


ExtWnd = flash.widget.Window([
    flash.widget.Text(0, 0, "IMDb - The Internet Movie Database"),
    flash.widget.Text(0, 1, "Give movie title and hit Enter to search!"),
    flash.widget.Text(0, 3, "Movie Title:"),
    flash.widget.Input(13, 3, flash.widget.MAX_WIDTH, None, start_search),
    flash.widget.List(0, 5, 40, flash.widget.MAX_HEIGHT, None, flash.widget.LISTBOX_SINGLE_SELECT, movie_title_click),
    flash.widget.View(42, 5, flash.widget.MAX_WIDTH, flash.widget.MAX_HEIGHT)
    ])
    

